Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bag
Class AbstractBagDecorator

    java.lang.Object
      |
      +--org.apache.commons.collections.collection.AbstractCollectionDecorator
            |
            +--org.apache.commons.collections.bag.AbstractBagDecorator

All Implemented Interfaces:
  Bag, Collection

Direct Known Subclasses:
  AbstractSortedBagDecorator, UnmodifiableBag

public abstract class AbstractBagDecorator
extends AbstractCollectionDecorator
implements Bag

Decorates another `Bag` to provide additional behaviour.

Methods are forwarded directly to the decorated bag.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.5 $ $Date: 2004/06/02 21:53:02 $
Author:
  Stephen Colebourne

Field Summary

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` | `AbstractBagDecorator()` Constructor only used in deserialization, do not use otherwise.
`protected` | `AbstractBagDecorator(Bag bag)` Constructor that wraps (not copies).

Method Summary
`boolean` | `add(Object object, int count)` Adds `nCopies` copies of the specified object to the Bag.
`protected Bag` | `getBag()` Gets the bag being decorated.
`int` | `getCount(Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
`boolean` | `remove(Object object, int count)` Removes `nCopies` copies of the specified object from the Bag.
`Set` | `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`add, addAll, clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`add, containsAll, iterator, remove, removeAll, retainAll, size`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Constructor Detail

### AbstractBagDecorator

    protected AbstractBagDecorator()

  Constructor only used in deserialization, do not use otherwise.

Since:
  Commons Collections 3.1

### AbstractBagDecorator

    protected AbstractBagDecorator(Bag bag)

  Constructor that wraps (not copies).

Parameters:
  `bag` - the bag to decorate, must not be null
Throws:
  `IllegalArgumentException` - if list is null

Method Detail

### getBag

    protected Bag getBag()

  Gets the bag being decorated.

  Returns:
    the decorated bag

### getCount

    public int getCount(Object object)

  Description copied from interface: `Bag`
  Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.

  Specified by:
    `getCount` in interface `Bag`
  Parameters:
    `object` - the object to search for
  Returns:
    the number of occurrences of the object, zero if not found

### add

    public boolean add(Object object,
                       int count)

  Description copied from interface: `Bag`
  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

  Specified by:
    `add` in interface `Bag`
  Parameters:
    `object` - the object to add
    `count` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### remove

    public boolean remove(Object object,
                          int count)

  Description copied from interface: `Bag`
  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Specified by:
    `remove` in interface `Bag`
  Parameters:
    `object` - the object to remove
    `count` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### uniqueSet

    public Set uniqueSet()

  Description copied from interface: `Bag`
  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Specified by:
    `uniqueSet` in interface `Bag`
  Returns:
    the Set of unique Bag elements

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.